/* GCC */

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

const int loopTimes=250;

using namespace std;
int n, m;
int currL, bestL=1000000000;
vector<int> best, curr;
vector<int> pairs;

void show(vector<int> a){
    for(int i=0; i<a.size(); i++){
        cout<<a[i]<<' ';
    }
    cout<<endl;
}

int findLength(vector<int> pos){
    int sum=0, i;
    for(i=0; i<m; i++){
        sum+=abs(pos[pairs[i*2]]-pos[pairs[i*2+1]]);
    }
    return sum;
}

void findBest(){
    int oldL=currL;
    vector<int> currBest=curr;
    int i, z;
    for(i=1; i<n; i++){
        for(z=i+1; z<=n; z++){
            swap(curr[z], curr[i]);
            int localLen=findLength(curr);
            if (localLen<currL){
                currBest=curr;
                currL=localLen;
            }
            swap(curr[z], curr[i]);
        }
    }
    if(currL<oldL) {
        curr=currBest;
        findBest();
    }
}

int main(){
    ifstream fin("servers.in");
    ofstream fout("servers.out");

    fin>>n;
    best=vector<int>(n+1);
    curr=vector<int>(n+1);

    //fill started
    int i, z;
    for(i=0; i<=n; i++){
        curr[i]=i;
    }

    fin>>m;
    //read plaged
    int a, b;
    for(i=0; i<m; i++){
        fin>>a>>b;
        pairs.push_back(a);
        pairs.push_back(b);
    }

    //check different positions
    for(i=0; i<loopTimes; i++){
        random_shuffle(curr.begin()+1, curr.end());
        currL=findLength(curr);
        findBest();
        if(currL<bestL){
            best=curr;
            bestL=currL;
        }
        if(bestL==m) break;
    }

    fout<<bestL<<endl;

    //fill final
    vector<int> final(n+1);
    for(i=1; i<=n; i++){
        final[best[i]]=i;
    }

    //file out
    fout<<final[1];
    for(i=2; i<=n; i++){
        fout<<' '<<final[i];
    }
    fout<<endl;



    fout.close();
    fin.close();
    return 0;
}
