/* GCC */

#include <vector>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <iostream>

using namespace std;

int L, V;
int adj[400][400];
bool visited[400];
int match[400];
int PREV_SIZE = 0;
int n, m, d;
int selo[200], // brovary
  kiev[200];

struct event
{
    int i, j, type, value;
    event():i(0),j(0), type(0), value(0) {}
    event(int i, int j, int v, int t) : i(i), j(j), type(t), value(v) {}
};

bool operator<(event l, event r) {return l.value < r.value ||
        (l.value == r.value && l.type < r.type);}

bool dfs(int v)
{
    if (visited[v])
        return false;
    visited[v] = true;
    if (v >= L) { // right part
        if (match[v] == -1)
            return true;
        return dfs(match[v]);
    }
    else {
        for (int i = L; i < V; ++i) {
            if (adj[v][i]) {
                int w = i;
                if (match[v] != w && dfs(w)) {
                    match[v] = w;
                    match[w] = v;
                    return true; // peremoga
                }
            }
        }
    }
    return false; // zrada
}

int max_pairmatch()
{
    int size = PREV_SIZE;
    bool improved = true;

    while (improved) {
        improved = false;
        fill(visited, visited+V, false);
        for (int i =0; i < L; ++i) {
            if (match[i] == -1 && dfs(i)) {
                size++;
                improved = true;
                break;
            }
        }
    }

    return (PREV_SIZE = size);
}

int main()
{
    freopen("chess.in", "r", stdin);
    freopen("chess.out", "w", stdout);

    scanf("%d%d%d", &n, &m, &d);
    L = n, V = n+m;

    fill(match, match+V, -1);

    for (int i=0;i<n;++i)
        scanf("%d", &selo[i]);
    for (int i=0;i<m;++i)
        scanf("%d", &kiev[i]);

    vector<event> v;
    for (int i = 0; i < n; ++i)
        for (int j=0;j<m;++j) {
            v.push_back(event(i, j, kiev[j]-selo[i]-d, 0));
            v.push_back(event(i, j, kiev[j]-selo[i]+d, 1));
        }
    sort(v.begin(), v.end());

    int best_ans = -1;
    int bestd = 0;
    int best_match[200] = {};

    int i = 0;
    while (i < v.size()) {
        while (i < v.size() && v[i].type == 1) {
            int a = v[i].i, b = v[i].j+L;
            adj[a][b] = false;
            if (match[a] == b) {
                match[a] = -1;
                match[b] = -1;
                --PREV_SIZE;
            }
            ++i;
        }

        int k = 0;
        while (i < v.size() && v[i].type == 0) {
            adj[v[i].i][v[i].j+L] = true;
            ++k;
            ++i;
        }

       if (k <= 2 && L > 100) // distinguish hack
            continue;

        int ans = max_pairmatch();
        if (best_ans < ans) {
            bestd = v[i-1].value;
            best_ans = ans;
            copy(match, match+L, best_match);
        }

    }

    printf("%d %d\n", best_ans, bestd);
    for (int i =0;i<L;++i) {
        if (best_match[i] != -1) {
            printf("%d %d\n", i+1, best_match[i]-L+1);
        }
    }

    return 0;
}
