/* GCC */

#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <utility>

using namespace std;

#define X first
#define Y second

vector<pair<int, int> > p;

const int TimeLimit = 0.6*CLOCKS_PER_SEC;

int getCost(const vector<int>& perm)
{
    static int pos[25];
    for (int i = 0; i < perm.size(); ++i)
        pos[perm[i]] = i;
    int ans = 0;
    for (int i = 0;i<p.size(); ++i)
        ans += abs(pos[p[i].X] - pos[p[i].Y]);
    return ans;
}

int main()
{
    clock_t t0 = clock();

    freopen("servers.in", "r", stdin);
    freopen("servers.out", "w", stdout);
    int n, m;
    scanf("%d%d", &n, &m);

    for (int i=0;i<m;++i) {
        int a, b;
        scanf("%d%d", &a, &b);
        --a,--b;
        p.push_back(make_pair(a, b));
    }
    //srand(time(0));

    vector<int> perm, best_perm(n);
    for (int i=0;i<n;++i)
        perm.push_back(i);
    int best_cost = 1e9;

    while (clock()-t0 < TimeLimit) {
        random_shuffle(perm.begin(), perm.end());

        int cost = getCost(perm);
        bool hasNext = true;

        while (clock()-t0 < TimeLimit && hasNext) {
            hasNext = false;

            for (int i=0;i<n;++i){
                for (int j=i+1;j<n;++j){
                    swap(perm[i], perm[j]);
                    int newCost = getCost(perm);
                    if (newCost < cost) {
                        hasNext = true;
                        cost = newCost;
                        break;
                    }
                    swap(perm[i], perm[j]);
                }
            }

        }

        if (cost < best_cost) {
            best_cost = cost;
            copy(perm.begin(), perm.end(), best_perm.begin());
        }
    }

    printf("%d\n", best_cost);
    for (int i=0;i<n;++i) {
        printf("%d%s", best_perm[i]+1, ((i!=n-1)?" ":"\n"));
    }


    return 0;
}
