/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <algorithm>
#include <vector>
#include <string>
#include <string.h>

#define m_p make_pair
#define X first
#define Y second

using namespace std;

const int inf = 1000000000;

struct evn {
    int c1, c2, cd, t;
};

inline bool operator <(const evn &a, const evn &b) {
    if(a.cd != b.cd) return a.cd < b.cd;
    else if(a.t != b.t) return a.t < b.t;
    else if(a.c1 != b.c1) return a.c1 < b.c1;
    else return a.c2 < b.c2;
}

int a, b, c, d, i, j, m, n, p, pr, k, ans, ansd;
int com1[201], com2[201];
evn ev[81000];
int lp[201], q[201];
vector <int> sm[201];
bool used[201], edge[201][201];
int iter;

inline bool dfs(int v) {
    if(used[v]) return 0;
    
    used[v] = 1;
    int i = 0;
    while(i < sm[v].size()) {
        if(!edge[v][sm[v][i]]) {
            swap(sm[v][i], sm[v][sm[v].size() - 1]);
            sm[v].pop_back();
            continue;
        }
        
        if(q[sm[v][i]] == -1 || dfs(q[sm[v][i]])) {
            q[sm[v][i]] = v;
            lp[v] = sm[v][i];
            return 1;
        }
        i++;
    }
    return 0;
}

inline void match() {
    b = -1;
    while(p != b) {
        b = p;
        memset(used, 0, sizeof(used));
        for(int i = 0; i < n; i++)
            if(lp[i] == -1 && dfs(i))
                p++;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    freopen("chess.in", "r", stdin);
    freopen("chess.out", "w", stdout);
    
    cin >> n >> m >> a;
    
    for(i = 0; i < n; i++)
        cin >> com1[i];
    
    for(i = 0; i < m; i++)
        cin >> com2[i];

    k = 0;
    memset(edge, 0, sizeof(edge));
    
    for(i = 0; i < n; i++)
        for(j = 0; j < m; j++) {
            ev[k].c1 = i; ev[k].c2 = j; ev[k].cd = com2[j] - com1[i] - a; ev[k++].t = 0;
            ev[k].c1 = i; ev[k].c2 = j; ev[k].cd = com2[j] - com1[i] + a; ev[k++].t = 1;
        }
    
    sort(ev, ev + k);
        
    p = 0;
    memset(lp, -1, sizeof(lp));
    memset(q, -1, sizeof(q));
    
    pr = -1;
    ans = 0;
    ansd = -inf;
    for(i = 0; i < n; i++)
        sm[i].clear();
    
    for(i = 0; i < k; i++) {
        if(ev[i].t == 0) {
            pr = 0;
            sm[ev[i].c1].push_back(ev[i].c2);
            edge[ev[i].c1][ev[i].c2] = 1;
        } else {
            if(pr == 0) match();
            if(p > ans) 
                ans = p, ansd = i;
            pr = 1;
            
            if(lp[ev[i].c1] == ev[i].c2) {
                p--;
                lp[ev[i].c1] = -1;
                q[ev[i].c2] = -1;
            }
            edge[ev[i].c1][ev[i].c2] = 0;
        }
    }
    for(i = 0; i < n; i++)
        sm[i].clear();
    
    memset(edge, 0, sizeof(edge));
    memset(q, -1, sizeof(q));
    memset(lp, -1, sizeof(lp));
    
    for(i = 0; i < ansd; i++) {
        if(ev[i].t == 0) {
            sm[ev[i].c1].push_back(ev[i].c2);
            edge[ev[i].c1][ev[i].c2] = 1;
        } else edge[ev[i].c1][ev[i].c2] = 0;
    }
    
    cout << ans << ' ' << ev[ansd - 1].cd << '\n';
    match();
    for(i = 0; i < n; i++) 
        if(lp[i] != -1)
            cout << i + 1 << ' ' << lp[i] + 1 << '\n';
        
    return 0;
}
