/* GCC */
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAX=401;

bool cmp (pair <int, int> a, pair <int, int> b)
{
    return a.first<b.first||(a.first==b.first&&a.second>b.second);
}

int n, m, d, ans, ans_d;
int level[MAX], match[MAX], ans_match[MAX];
vector <int> arr[MAX];
bool vis[MAX];

void build(int delta)
{
    for(int i=1; i<=n+m; ++i)
        arr[i].clear();
    for(int i=1; i<=n; ++i)
    {
        for(int j=n+1; j<=n+m; ++j)
        {
            if(abs(level[i]+delta-level[j])<=d)
            {
                arr[i].push_back(j);
                arr[j].push_back(i);
            }
        }
    }
}

bool dfs(int v)
{
    if(vis[v]) return false;
    vis[v]=true;
    if(v<=n)
    {
        for(int i=0; i<arr[v].size(); ++i)
        {
            int to=arr[v][i];
            if(dfs(to))
            {
                match[v]=to;
                match[to]=v;
                return true;
            }
        }
        return false;
    }
    else
    {
        if(!match[v]) return true;
        return dfs(match[v]);
    }
}

void max_match(int delta)
{
    build(delta);
    bool changed=true;
    for(int i=1; i<=n+m; ++i)
        match[i]=false;
    int cnt=0;
    while(changed)
    {
        changed=false;
        for(int i=1; i<=n+m; ++i)
            vis[i]=false;
        for(int i=1; i<=n; ++i)
        {
            if(!match[i])
            {
                if(dfs(i))
                {
                    ++cnt;
                    changed=true;
                }
            }
        }
    }
    if(cnt>ans)
    {
        ans=cnt;
        ans_d=delta;
        for(int i=1; i<=n+m; ++i)
            ans_match[i]=match[i];
    }
}

int main()
{
    ios::sync_with_stdio(0);
    ifstream cin("chess.in");
    ofstream cout("chess.out");
    cin >> n >> m >> d;
    for(int i=1; i<=n; ++i)
        cin >> level[i];
    for(int i=1; i<=m; ++i)
        cin >> level[n+i];
    vector < pair <int, int> > vec;
    for(int i=1; i<=n; ++i)
    {
        for(int j=n+1; j<=n+m; ++j)
        {
            vec.push_back(make_pair(level[j]-level[i]-d, +1));
            vec.push_back(make_pair(level[j]-level[i]+d, -1));
        }
    }
    sort(vec.begin(), vec.end(), cmp);
    int previous=1;
    for(int i=0; i<vec.size(); ++i)
    {
        if(previous==1&&vec[i].second==-1)
            max_match(vec[i-1].first);
        previous=vec[i].second;
    }
    max_match(vec[vec.size()-1].first);
    cout << ans << ' ' << ans_d << endl;
    for(int i=1; i<=n; ++i)
        if(ans_match[i])
            cout << i << ' ' << ans_match[i]-n << endl;
    return 0;
}
