/* GCC */
#include <iostream>
#include <ctime>
#include <cstdlib>
#include <fstream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

const int MAX=21, MAGIC=151, INF=1e9+1;

int n, m;
pair<int, int> edge[MAX*MAX];
int pos[MAX];

int cost(vector <int> & vec)
{
    for(int i=0; i<n; ++i)
        pos[vec[i]]=i;
    int ret=0;
    for(int i=0; i<m; ++i)
        ret+=abs(pos[edge[i].first]-pos[edge[i].second]);
    return ret;
}

int main()
{
    ios::sync_with_stdio(0);
    ifstream cin("servers.in");
    ofstream cout("servers.out");
    cin >> n >> m;
    for(int i=0; i<m; ++i)
        cin >> edge[i].first >> edge[i].second;
    vector <int> best, now, nxt, tmp;
    int best_cost=INF;
    for(int i=1; i<=n; ++i)
        now.push_back(i);
    srand(time(NULL));
    for(int step=0; step<MAGIC; ++step)
    {
        random_shuffle(now.begin(), now.end());
        int now_cost=cost(now);
        while(true)
        {
            int nxt_cost=now_cost;
            tmp=now;
            for(int i=0; i<n; ++i)
            {
                for(int j=i+1; j<n; ++j)
                {
                    swap(tmp[i], tmp[j]);
                    int tmp_cost=cost(tmp);
                    if(tmp_cost<nxt_cost)
                    {
                        nxt=tmp;
                        nxt_cost=tmp_cost;
                    }
                    swap(tmp[i], tmp[j]);
                }
            }
            if(nxt_cost<now_cost)
            {
                now=nxt;
                now_cost=nxt_cost;
            }
            else break;
        }
        if(now_cost<best_cost)
        {
            best=now;
            best_cost=now_cost;
        }
    }
    cout << best_cost << endl;
    for(int i=0; i<n; ++i)
    {
        cout << best[i];
        if(i!=n-1) cout << ' ';
    }
    cout << endl;
    return 0;
}
